<?php

class YoutubeAPI
{
	private $ytusername;
	private $ytlimit;
	private $width;
	private $height;
	public  $cache = "youtubeCache";
	private $cacheTime; //Expiration time of cache
	public  $uploaded; //Upload date
	
	public function __construct($ytusername,$ytlimit,$width,$height,$cacheTime)
	{
		$this->ytusername = $ytusername;
		$this->ytlimit    = $ytlimit;
		$this->width      = $width;
		$this->height     = $height;
		$this->cacheTime  = $cacheTime;
	}
	
	public function getFeed()
	{
		// set feed URL
		
		if(!$this->getCachedYoutubeData($this->ytusername))
		{
		$jsoncURL = 'http://gdata.youtube.com/feeds/api/users/'.$this->ytusername.'/uploads?v=2&alt=jsonc&max-results='.$this->ytlimit;
   			if($jsonc = file_get_contents($jsoncURL))
			{
				$ytvideo = json_decode($jsonc);
				$this->cacheYoutubeData($this->ytusername,$jsonc);
			}
			else
			{
				echo '<span id="warning">Api(YouTube) call failed</span>';
			}
			
		}
		else
		{
			$ytvideo = $this->getCachedYoutubeData($this->ytusername);
		}
			
			//Youtube video
			
			foreach($ytvideo->data->items as $row)
			{
				$this->uploaded = strtotime($row->uploaded);
			
				$content = 5;//Youtube stream
				$feed['bar'] .= "<li><a data='".$row->content->$content."' class='videoClick' href='".$_SERVER['PHP_SELF']."/?video_id=".$row->id."'><img src='".$row->thumbnail->sqDefault."' width='150' /></a><div class='video_desc_box'><span class='video_title'>".$row->title."</span><span class='video_desc'>".$row->description."</span><span class='video_date'>".date('Y-m-d H:i:s',$this->uploaded)."</span></div></li>";
				
			$feed['playerUrl'][] = $row->content->$content;		
			$feed['date'][] = date('Y-m-d H:i:s',$this->uploaded);
			}	
			
			
			return $feed;
		
	}
	
	public function cacheYoutubeData($user, $data)
		{
			// Load the cache stored in the db
			$youtubeCache = get_option($this->cache);
			if(empty($youtubeCache))
			{
				$youtubeCache = array();
			}
			$youtubeCache[$user] = $data;
			$youtubeCache[$user.'-date'] = date('Y-m-d H:i:s',mktime(date('H')+$this->cacheTime)); //Setter dato for lagret cache
			// Store updated options back in the database.
			update_option($this->cache, $youtubeCache);
		}
		
	public function getCachedYoutubeData($user)
	{
		$youtubeCache = get_option($this->cache);
		if(empty($youtubeCache) || empty($youtubeCache[$user]) || empty($youtubeCache[$user.'-date'])
			|| strtotime($youtubeCache[$user.'-date']) < strtotime(date('Y-m-d H:i:s')))
		{
			return false;
		}
		else
		{   
			 $jsonc = $youtubeCache[$user];
			 $ytvideo = json_decode($jsonc); 
			 return $ytvideo;
			 
		}
	}
	
}
?>